IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc

    Get_ID_String    PROTO :DWORD
    Get_Brand_String PROTO :DWORD

    iType PROTO

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pbuf  :DWORD                  ; pointer
    LOCAL buffer[128]:BYTE              ; buffer

    mov pbuf, ptr$(buffer)

    invoke Get_ID_String,pbuf
    print ltrim$(pbuf),13,10

    invoke Get_Brand_String,pbuf
    print ltrim$(pbuf),13,10

    invoke iType

    ret

main endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

Get_ID_String proc pBuffer:DWORD

    push ebx
   
    mov eax, 0                          ; set ID string for Intel
    cpuid

    mov eax, [esp+4][4]                 ; (pBuffer) load buffer address into ESI

    mov [eax],    ebx                   ; write results to buffer
    mov [eax+4],  edx
    mov [eax+8],  ecx
    mov [eax+12], DWORD PTR 0           ; terminate result

    pop ebx
   
    ret 4

Get_ID_String endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

Get_Brand_String proc pBuffer:DWORD

    push ebx
    push esi

    mov esi, [esp+4][8]                 ; (pBuffer) load buffer address into ESI
   
    mov eax, 80000002h                  ; extended function 2
    cpuid

    mov [esi],    eax                   ; write results to buffer
    mov [esi+4],  ebx
    mov [esi+8],  ecx
    mov [esi+12], edx

    mov eax, 80000003h                  ; extended function 3
    cpuid

    mov [esi+16], eax                   ; write results to buffer
    mov [esi+20], ebx
    mov [esi+24], ecx
    mov [esi+28], edx

    mov eax, 80000004h                  ; extended function 4
    cpuid

    mov [esi+32], eax                   ; write results to buffer
    mov [esi+36], ebx
    mov [esi+40], ecx
    mov [esi+44], edx

    mov [esi+48], DWORD PTR 0           ; terminate result

    pop esi
    pop ebx
   
    ret 4

Get_Brand_String endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

iType proc

    LOCAL ecx_  :DWORD
    LOCAL edx_  :DWORD

    mov eax, 1
    cpuid

    mov ecx_, ecx
    mov edx_, edx

  ; bit 20 ecx = sse4.2       6
  ; bit 19 ecx = sse4.1       5
  ; bit  0 ecx = sse3         4

    mov eax, ecx_
    and eax, 00000000000100000000000000000000b      ; test bit 20
    ror eax, 20

    print str$(eax)," SSE 4.2",13,10

    mov eax, ecx_
    and eax, 00000000000010000000000000000000b      ; test bit 19
    ror eax, 19

    print str$(eax)," SSE 4.1",13,10

    mov eax, ecx_
    and eax, 00000000000000000000000000000001b

    print str$(eax)," SSE 3",13,10

  ; bit 26 edx = sse2         3
  ; bit 25 edx = sse          2
  ; bit 23 edx = mmx          1

    mov eax, edx_
    and eax, 00000100000000000000000000000000b
    ror eax, 26

    print str$(eax)," SSE 2",13,10

    mov eax, edx_
    and eax, 00000010000000000000000000000000b
    ror eax, 25

    print str$(eax)," SSE",13,10

    mov eax, edx_
    and eax, 00000000100000000000000000000000b
    ror eax, 23

    print str$(eax)," MMX",13,10

    ret

iType endp

; 

end start





















